classdef CCalibrator < CDevice
    %CCALIBRATOR NiHu.Lab class for Calibrator handling
    %
    % See also: CDevice, CCalSelect, CCalSelectView, CCalibration, CCalPanel
    
    properties (SetAccess = immutable)
        Quantity    % CQuantity object
        Level       % Calibration RMS level
        Frequency   % Calibration frequency in Hz
    end
    
    methods
        function obj = CCalibrator(vendor, model, sn, eu, level, freq)
            obj = obj@CDevice(vendor, model, sn);
            obj.Quantity = CQuantity.fromEU(eu);
            obj.Level = level;
            obj.Frequency = freq;
        end
    end
end
