classdef CChSetupSensitive < handle
    %CCHSETUPSENSITIVE object sensitive to Channel Setup Change
    
    properties (Access = protected)
        ChannelSetup        % handle to CChannelSetup class
        listChSetupChange   % listener to catch change event
        chSetupChanged      % boolean indicating whether Channel Setup has been changed or not
    end
    
    methods
        function obj = CChSetupSensitive(chsetup)
            %CCHSETUPSENSITIVE constructor
            
            obj.chSetupChanged = true;
            obj.ChannelSetup = chsetup;
            obj.listChSetupChange = addlistener(obj.ChannelSetup, 'channelSetupChange', @(src,event)channelSetupChangeCallback(obj));
        end
        
        function delete(obj)
            %DELETE destructor
            
            delete(obj.listChSetupChange)
        end
        
        function channelSetupChangeCallback(obj)
            %CHANNELSETUPCHANGECALLBACK Called when listChSetupChange is activated
            
            obj.chSetupChanged = true;
        end
    end % of public methods
end % of classdef
