classdef CHardware < handle
    %CHARDWARE A measurement hardware abstract base class
    
    properties
    end % of properties
    
    methods
        function obj = CHardware()
        end
    end % of methods
    
    methods (Abstract = true)
        getFsRange(obj);
        
        MonitorInit(obj, Channels);
        MonitorStart(obj, Fs, nSamples);
        MonitorAcq(obj, nSamples);
        MonitorStop(obj);
        MonitorClose(obj);
        
        TransferInit(obj, InputChannels, OutputChannels);
        TransferAcq(obj, nPre, nAverage, nPost, Fs, x);
        TransferClose(obj);
        
        ImpactInit(obj, Channels);
        ImpactArm(obj, nSamples, nPretrigSamples, Fs);
        ImpactWaitForTrigger(obj, trigLevel, trigCh);
        ImpactAcq(obj);
        ImpactClose(obj);
    end % of abstract methods
end % of classdef
