classdef CNi9234Hardware < CHardware
    %CNI9234HARDWARE Base class of all Ni 2934 modules
    
    properties (Constant = true)
        % the maximal data rate of the NI 9234 modules
        maxDataRate = 13.1072e6/256;
        % selectable frequencies: the maximal data rate divided by integers
        fsRange = CNi9234Hardware.maxDataRate ./ (1:31);
    end
    
    methods
        function obj = CNi9234Hardware()
            obj = obj@CHardware();
        end
        
        function fsrange = getFsRange(obj) %#ok<MANU>
            % return the sampling frequency range
            fsrange = CNi9234Hardware.fsRange;
        end
    end % of methods
end % of class CNi9234Hardware
