classdef CQuantity
    %CQUANTITY NiHu.Lab class for Quantity handling
    
    properties (SetAccess = immutable)
        EU          % Engineergin Unit (string)
        isScalar    % indicates whther quantity is scalar or vector
    end
    
    methods
        function q = CQuantity(eu, isscalar)
            %CQUANTITY constructor
            q.EU = eu;
            q.isScalar = isscalar;
        end
        
        function t = textID(obj)
            t = upper(obj.char());
        end
    end % of public methods
    
    methods (Static)
        function q = fromtext(text)
            [m, s] = enumeration('CQuantity');
            q = m(strcmpi(text, s));
        end
        
        function q = fromEU(eu)
            m = enumeration('CQuantity');
            q = m(ismember({m.EU}, eu));
        end
    end % of static methods
    
    enumeration
        Dimensionless('-', true);
        Voltage('V', true);
        Pressure('Pa', true);
        Force('N', false);
        Velocity('m/s', false);
        Acceleration('g', false);
        Time('s', true);
        Frequency('Hz', true);
    end
end % of classdef
