classdef CSetupClass < handle
    %CSETUPCLASS NiHu.Lab class to handle exit requests

    properties (Constant)
        itemWidth = 100;
        itemHeight = 20;
        legendWidth = 150;
        TableExtentCorrection = [0 0 30 18];
        ListBoxExtentCorrection = [0 0 20 0];
    end
    
    properties
        askAgain = true;
    end
    
    methods (Access = private)
        function obj = CSetupClass
            obj.askAgain = true;
        end
    end
    
    methods (Static = true)
        function obj = getInstance
            persistent uniqueInstance;
            if isempty(uniqueInstance)
                uniqueInstance = CSetupClass();
            end
            obj = uniqueInstance;
        end
        
        function really = exitRequest
            obj = CSetupClass.getInstance;
            if obj.askAgain
                f0 = get(0, 'CurrentFigure');
                
                f = figure('MenuBar', 'none',...
                    'NumberTitle', 'off', ...
                    'Name', CBabel.getInstance().getText('CLOSE_DIALOG'), ...
                    'Color', get(0,'defaultUicontrolBackgroundColor'),...
                    'WindowStyle', 'modal',...
                    'CloseRequestFcn', '', ...
                    'Visible', 'off');
                butOK = uicontrol('parent', f,...
                    'Style', 'PushButton', ...
                    'units', 'pixels', ...
                    'position', [0 0 CSetupClass.itemWidth CSetupClass.itemHeight], ...
                    'Tag', 'YES',...
                    'String', CBabel.getInstance().getText('YES'),...
                    'Callback', @(src,event)butCallback(src, true));
                butCan = uicontrol('parent', f,...
                    'Style', 'PushButton', ...
                    'units', 'pixels', ...
                    'position', [0 0 CSetupClass.itemWidth CSetupClass.itemHeight], ...
                    'Tag', 'NO', ...
                    'String', CBabel.getInstance().getText('NO'),...
                    'Callback', @(src,event)butCallback(src, false));
                txt1 = uicontrol('parent', f,...
                    'Style', 'Text',...
                    'Tag', 'QUIT_CONFIRM', ...
                    'String', CBabel.getInstance().getText('QUIT_CONFIRM'));
                set(txt1, 'position', get(txt1, 'extent'));
                txt2 = uicontrol('parent', f,...
                    'Style', 'Text',...
                    'Tag', 'NEVER_ASK_AGAIN', ...
                    'String', CBabel.getInstance().getText('NEVER_ASK_AGAIN'));
                set(txt2, 'position', get(txt2, 'extent'));
                chk = uicontrol('parent', f,...
                    'Style', 'CheckBox',...
                    'Tag', 'chk');
                l = {{txt1 [0 0]};
                    {{{butOK [0 0]}, {butCan [0 0]}} [0 0]};
                    {{{txt2 [0 0]}, {chk [0 0]}} [0 0]}};
                GuiLayout.ApplyLayout(f, l);
                GuiLayout.MoveGuiRel(f, f0);
                movegui(f, 'onscreen');
                set(f, 'Visible', 'on');
                
                uiwait;
                
                data = guidata(f);
                really = data.really;
                obj.askAgain = data.askAgain;
                delete(f);
            else
                really = true;
            end
        end
    end
end

function butCallback(src, really)
data = guidata(src);
handles = guihandles(src);
data.really = really;
data.askAgain = ~get(handles.chk, 'value');
guidata(src, data);
uiresume;
end
