#ifndef AMPLIFIER_H
#define AMPLIFIER_H

#include "Device.h"

class CAmplifier : public CDevice
{
	unsigned numChannels;
	bool provideICP;

public:
	CAmplifier(const std::string &vendor = "", const std::string &model = "", unsigned serialNumber = 0, unsigned numChannels = 0, bool provideICP = false)
		: CDevice(vendor, model, serialNumber),
		numChannels(numChannels),
		provideICP(provideICP)
	{
	}

	unsigned getNumChannels(void) const { return numChannels; }
	unsigned getProvideICP(void) const { return provideICP; }

	virtual std::istream & serialise(std::istream &is);
	virtual std::ostream & serialise(std::ostream &os) const;
};

#endif

