#ifndef POOL_HPP
#define POOL_HPP

#include <vector>
#include <fstream>

#include "Serialisable.h"

template <class C>
class CPool : public std::vector<C>, public CSerialisable
{
public:
	CPool(const char *fname)
	{
		std::ifstream is(fname);
		if (is.fail())
			throw "Could not open file";
		is >> (*this);
	}

	std::ostream & serialise(std::ostream &) const;
	std::istream & serialise(std::istream &);
};

template <class C>
std::ostream & CPool<C>::serialise(std::ostream &os) const
{
	typedef typename std::vector<C>::const_iterator ci;
	for (ci i = this->begin(); i != this->end(); ++i)
		os << *i << std::endl;
	return os;
}

template <class C>
std::istream & CPool<C>::serialise(std::istream &is)
{
	C c;
	while (is >> c)
		push_back(c);
	return is;
}

#endif
