#include "Calibrator.h"
#include "Amplifier.h"
#include "Sensor.h"
#include "Pool.hpp"

#include <iostream>

int main(void)
{
	try
	{
		CPool<CCalibrator> CP("data/Calibrators.txt");
		std::cout << CP << std::endl;
		CPool<CAmplifier> AP("data/Amplifiers.txt");
		std::cout << AP << std::endl;
		CPool<CSensor> SP("data/Sensors.txt");
		std::cout << SP << std::endl;
	}
	catch (const char *c)
	{
		std::cerr<< c << std::endl;
	}

	return 0;
}
