classdef NiHu
    % NiHu is a wrapper class of clas CNiHuLab.
    % class NiHu is defined so that one can start the software by
    % typing
    %
    % >> NiHu.Lab()
    
    methods (Static)
        function Lab(choices)
            % The static method Lab. The argument choices is a string or
            % cell string containing 'sim', 'daq' or 'crio'
            
            % argument check
            if nargin < 1
                choices = {};
            elseif ischar(choices)
                choices = cellstr(choices);
            end
            % check whether choices contains appropriate elements
            possibleChoices = {'sim', 'daq', 'crio', 'playrec', 'daqmx'};
            errorMembers = ~ismember(choices, possibleChoices);
            if any(errorMembers)
                error('Unknown hardware choice: %s', choices{find(errorMembers, 1, 'first')});
            end
            
            % run the software
            try
                N = CNiHuLab(choices);
                N.run();
            catch ME
                disp(ME.message);
            end
        end % of function Lab
    end % of static methods
end % of classdef
