clear;
load NQ data

figure;
formatfig([], [2.5 1.5 .5 .5]);
hold on;
for n = 9 : 17
    z = data{n}.q ./ data{n}.N;
    plot(z, data{n}.N, '.');
end
set(gca, 'xscale', 'log', 'yscale', 'log');
xlabel('Normalized Frequency (f / f_s) [-]');
ylabel('Number of samples');
set(gca, 'ytick', 2.^(9:17));
set(gca, 'xtick', 10.^(-6:0));
ylim([2^8 2^18]);
font_size(12);
line_width(.5);
print -dpng fucimethod