classdef Filterable
    properties
        values
    end
    
    methods
        function this = Filterable(values)
            this.values = values;
        end
        
        function result = filter(this, j, v)
            val = cell2mat({this.values}');
            result = this(ismember(val(:,j), v));
        end
        
        function f = getfield(this, j)
            f = cell2mat({this.values}');
            f = f(:,j);
        end
        
        function p = pivot(this, fields)
            ndim = numel(fields);
            sizes = zeros(1,ndim);
            f = this.getfield(fields);
            for dim = 1 : ndim
                sizes(dim) = numel(unique(f(:,dim)));
            end
            f = this.getfield(fields);
            index = (f-1) * cumprod([1 sizes(1:end-1)]')+1;
            p = cell(sizes);
            for i = 1 : numel(p)
                p{i} = this(index == i);
            end
        end
    end
end