function MD = MetaData(MD)

MainFigure = figure('MenuBar', 'none', 'NumberTitle', 'off',...
    'Name', 'MetaData', 'Resize', 'off');
uitable('parent', MainFigure, ...
    'ColumnName', MD.Fields, ...
    'ColumnFormat', MD.Format, ...
    'Data', MD.Values, ...
    'RowName', [], ...
    'ColumnEditable', true(size(MD.Fields)), ...
    'Tag', 'Table');

uicontrol('Parent', MainFigure, 'Style', 'Text', 'String', 'Name', 'Tag', 'tName');
uicontrol('Parent', MainFigure, 'Style', 'Text', 'String', 'Format', 'Tag', 'tFormat');
uicontrol('Parent', MainFigure, 'Style', 'Text', 'String', 'Items', 'Tag', 'tItems');
uicontrol('Parent', MainFigure, 'Style', 'Edit', 'String', 'Untitled', 'Tag', 'hName');
uicontrol('Parent', MainFigure, 'Style', 'PopupMenu', 'String', {'numeric', 'text', 'logical', 'select'}, 'Tag', 'hFormat');
uicontrol('Parent', MainFigure, 'Style', 'Edit', 'String', {'First', 'Second'}, 'Min', 1, 'Max', 3, 'Tag', 'hItems');

h = guihandles(MainFigure);
e = get(h.Table, 'extent');
set(h.Table, 'position', e);

e = get(hTable, 'extent');
set(hTable, 'position', e);

set(MainFigure, 'position', get(MainFigure, 'position').*[1 1 0 0] + e);


uiwait(MainFigure)

if ishandle(MainFigure)
    close(MainFigure)
end

end